const path = require("path");
const express = require("express");

module.exports = (options) => {	
	options = (typeof options === "object" && options instanceof Array === false) ? options : {};
	let useSlim = (options.hasOwnProperty("useSlim") && typeof options.useSlim === "boolean") ? options.useSlim : true;
	let useDefault = (options.hasOwnProperty("useDefault") && typeof options.useDefault === "boolean") ? options.useDefault : true;

	if (useSlim === false && useDefault === false) {
		throw new Error("Don't you want to use jQuery?!");
	}

	let jQueryRouter = express.Router();

	let jQueryDistFolder = path.resolve("node_modules", "jquery", "dist");

	if (useSlim) {
		jQueryRouter.use(`/jquery.slim.js`, (req, res) => {
			res.sendFile(path.join(jQueryDistFolder, "jquery.slim.js"));
		});

		jQueryRouter.use(`/jquery.slim.min.js`, (req, res) => {
			res.sendFile(path.join(jQueryDistFolder, "jquery.slim.min.js"));
		});

		jQueryRouter.use(`/jquery.slim.min.map`, (req, res) => {
			res.sendFile(path.join(jQueryDistFolder, "jquery.slim.min.map"));
		});
	}

	if (useDefault) {
		jQueryRouter.use(`/jquery.js`, (req, res) => {
			res.sendFile(path.join(jQueryDistFolder, "jquery.js"));
		});

		jQueryRouter.use(`/jquery.min.js`, (req, res) => {
			res.sendFile(path.join(jQueryDistFolder, "jquery.min.js"));
		});

		jQueryRouter.use(`/jquery.min.map`, (req, res) => {
			res.sendFile(path.join(jQueryDistFolder, "jquery.min.map"));
		});
	}

	return jQueryRouter;
}
